#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;
const long long mod = 1000 * 1000 * 1000 + 7;
class SccGraph{
    vector< vector<int> > v, vt;
    vector<int> postorder, vis, sizes;
    int n;
public:
    SccGraph(int sz){
        n = sz;
        sz++;
        v.resize(sz);
        vt.resize(sz);
        postorder.resize(sz);
        vis.resize(sz);
    }
    void addEdge(int a, int b){
        v[a].push_back(b);
        vt[b].push_back(a);
    }
    void dfs(int x){
        vis[x]=1;
        for(int i=0;i<v[x].size();i++)
            if(!vis[v[x][i]])
              dfs(v[x][i]);
        postorder.push_back(x);
    }
    void dfst(int x){
        vis[x]=0;sizes.back()++;
        for(int i=0;i<vt[x].size();i++)
            if(vis[vt[x][i]])
             dfst(vt[x][i]);
    }
    vector<int> getSCCSizes(){
        for(int i=1;i<=n;i++)
            if(!vis[i])
                dfs(i);
        reverse(postorder.begin(), postorder.end());
        for(auto node: postorder)
            if(vis[node]){
                  sizes.push_back(0);
                  dfst(node);
            }
        return sizes;
    }
};
int main()
{
    int type, n, m, q;
    //freopen("data.in", "r", stdin);
    cin>>type;
    cin>>n>>m>>q;
    SccGraph graph(n);
    for(int i=1;i<=m;i++)
    {
        int a, b;
        cin>>a>>b;
        graph.addEdge(a, b);
    }
    auto sizes = graph.getSCCSizes();
    vector<int> freq(n + 1);
    vector<int> ans(q, 0);
    for(auto sz: sizes){
        freq[sz]++;
    }
    if(type == 1){
        for(int sz=1; sz <=n; sz++){
            long long pw = freq[sz];
            if(!pw) continue;
            for(int i=1; i<=q; i++){
                pw=(pw*(long long)sz)%mod;
                ans[i-1] = (ans[i-1]+pw)%mod;
            }
        }

    } else {
        for(int sz=1; sz <=n; sz++){
            long long fact = freq[sz];
            if(!fact) continue;
            for(int i=1; i<=sz; i++){
                fact=(fact*(long long)(sz-i+1))%mod;
                ans[i-1] = (ans[i-1]+fact)%mod;
            }
        }
    }
    for(auto res: ans)
        cout<<res<<'\n';
    return 0;
}
